#include <math.h>
#include <stdlib.h>

#define CGAL_BEGIN_NAMESPACE namespace CGAL {
#define CGAL_END_NAMESPACE }

#include <CGAL/basic.h>
#include <CGAL/Cartesian.h>
#include <CGAL/Bench.h>
#include <CGAL/Bench.C>
#include <CGAL/Bench_parse_args.h>
#include <CGAL/Bench_parse_args.C>
#include <approx_curve_segment.h>


typedef CGAL::Cartesian<double>        R;
typedef R::Point_2                     Point;
typedef CGAL::Arc_2<R>                 Arc;
typedef R::Circle_2                    Circle;
typedef R::Line_2                      Line;


class Bench_find_farthest{

 protected:

 public:
  Arc arc;
  Line line;
  Point point;

  Bench_find_farthest() {}
  void set (Point source, Point target, Point p3)
    {
      Circle circle(source,p3,target);
      Arc arc(circle,source,target);
      Line line(source,target);
    }

  int init (void) {return 0;}
  void clean(void) {}
  void sync(void) {}
  void op(void) {arc.find_farthest(arc,line,point);}

};

int main (int argc,char *argv[])
{
  Point p1(11,12),p2(23,14),p3(25,11); 
  

  CGAL::Bench_parse_args parseArgs(argc,argv);

  int rc = parseArgs.parse();
  if (rc > 0) return 0;
  if (rc < 0) return rc;
  int seconds = parseArgs.get_seconds();

  CGAL::Bench<Bench_find_farthest> bench ("find_farthest", seconds);

  Bench_find_farthest& benchable = bench.get_benchable();
  benchable.set(p1,p2,p3);
  bench();

  return 0;
}
