#include <math.h>

#define CGAL_BEGIN_NAMESPACE namespace CGAL {
#define CGAL_END_NAMESPACE }

#include <CGAL/Bench.h>
#include <CGAL/Bench.C>
#include <CGAL/Bench_parse_args.h>
#include <CGAL/Bench_parse_args.C>

class Bench_sqrt {
private:
  double n;
public:
  Bench_sqrt() : n(M_PI) {}
  int init(void) { return 0; }
  void clean(void) {}
  void sync(void) {}
  void op(void) { sqrt(n); }
};

int main(int argc, char * argv[])
{
  CGAL::Bench_parse_args parseArgs(argc, argv);
  int rc = parseArgs.parse();
  if (rc > 0) return 0;
  if (rc < 0) return rc;
  int seconds = parseArgs.get_seconds();
  CGAL::Bench<Bench_sqrt> bench("Square root", seconds);
  bench();
  return 0;
}
